#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "hdfi.h"
#include "crisSisGetUtilities.h"

uint32 *getTimeStampsOfDaysStructs(int day1996, char *structName) {
    char *pStructs, *pStructs_0;
    uint32 *pStamps_0, *pStamps, startStamp;
    int structCount, structSize;

    pStructs_0 = (char *) getDaysStructs(day1996, structName);

    structSize = getStructSizeFromName(structName);
    pStructs = pStructs_0;
    structCount = 0;
    while (getTimeStamp(pStructs, structName)) {
	structCount++;
	pStructs += structSize;
    }

    pStamps_0 = calloc((structCount * 2) + 1, sizeof(uint32));

    pStamps = pStamps_0;
    pStructs = pStructs_0;
    while ((startStamp = getTimeStamp(pStructs, structName))) {
	*pStamps = startStamp;
	pStamps++;
	*pStamps = getStopTimeStamp(pStructs, structName);

	    /* avoid confusion with terminal zero value in the array */
	if (*pStamps == 0) *pStamps = -1L;

	pStamps++;
	pStructs += structSize;
    }
    *pStamps = 0L;

    free(pStructs_0);

    return pStamps_0;
}
